<template lang='pug'>
mixin prop(name)
  li #[strong.text-info= name+': ']
    block

Example(title='EventSource Example' :maxState="0")
  template(v-slot:description)
    h5 This is an EventSource example
    p Click on #[em code] to view and modify its code.

  template(v-slot:interface)
    div #[strong Properties:]
      ul
        +prop("src") event source url
        +prop("json") parse messages data payload as JSon and emit only the parsed object

    div #[strong Data:]
      ul
        +prop("message") last message data, either raw or in JSon

    div #[strong Events:]
      ul
        +prop("error") handle errors from underlying EventSource, errors are sent to the logger if no listener is set
        +prop("message") connect to "message" events from the EventSource
        +prop("<event>") connect to any custom event from the EventSource

    div #[strong Slots:]
      ul
        +prop("default") default slot with "message" binding

  template(v-slot:code)
    template(v-pre).
      .row.justify-content-center
        BaseEventSource(:src='$butils.currentUrl() + "/sse"')
          template(v-slot='es')
            | Event received: {{ es.message }}
</template>
<script>

import Example from "./AppExample.vue";

export default {
  name: "ExampleCard",
  components: { Example }
};

</script>
